/*
    Mastermind 1.1
    Copyright (C) 2003 Christian Helbling
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


// C Header File
// Created 04.12.2003; 15:17:01



#ifndef	_MASTERMIND_HEADER
#define _MASTERMIND_HEADER


#define	NR_OF_SYMBOLS	10
#define	NR_OF_HISTORY_ENTRIES	100
#define SAVEFILE	"mstrmsav"

const char *titel = "Mastermind v1.3";


static unsigned char symbols[10][8] = {{0x3C,0x66,0xC3,0x99,0x99,0xC3,0x66,0x3C},	//Symbol 1
															  		  {0xFF,0x99,0x99,0xFF,0xFF,0x99,0x99,0xFF},	//Symbol 2
																  	  {0xC3,0xE7,0x7E,0x3C,0x3C,0x7E,0xE7,0xC3},	//Symbol 3
																	    {0x7E,0xF7,0xE7,0x83,0xC1,0xE7,0xEF,0x7E},	//Symbol 4
																	    {0xFF,0xDB,0x81,0xDB,0xDB,0x81,0xDB,0xFF},	//Symbol 5
																	    {0xBD,0x18,0x81,0xC3,0xC3,0x81,0x18,0xBD},	//Symbol 6
																	    {0xFF,0xE7,0xEF,0xC7,0xEF,0xEF,0xCF,0xFF},	//Symbol 7
															 		    {0xCF,0xEF,0xCA,0xE0,0x07,0x53,0xF7,0xF3},	//Symbol 8
															 		    {0x42,0xDB,0x18,0x66,0x66,0x18,0xDB,0x42},	//Symobl 9
															 		    {0x99,0x24,0x5A,0xBD,0xBD,0x5A,0x24,0x99}};  //Symbol 10
															 		    
															 		    
static unsigned char question_mark[8] =	{0xC7,0xBB,0xFB,0xF7,0xEF,0xEF,0xFF,0xEF};	//Question mark
															 		    
static unsigned short int cursor1[12] = {0xFFF0,0x8010,0x8010,0x8010,
																 0x8010,0x8010,0x8010,0x8010,
																 0x8010,0x8010,0x8010,0xFFF0};

static unsigned short int cursor2[10] = {0xFFC0,0x8040,0x8040,0x8040,
																   0x8040,0x8040,0x8040,0x8040,
																   0x8040,0xFFC0};
																   
static unsigned char scrollLeft[8] = {0x10,0x30,0x70,0xF0,0xF0,0x70,0x30,0x10};

static unsigned char scrollRight[8] = {0x80,0xC0,0xE0,0xF0,0xF0,0xE0,0xC0,0x80};

static unsigned char flash[8] = {0x80,0xE0,0xF8,0xFE,0xFE,0xF8,0xE0,0x80};

typedef struct {
	int score;
	char name[10];
} HSC;


//functions:

int select (int, int, int, int, int *);

void showHighscores (HSC *, int *);

void InputStr(char *, unsigned short, int, int);

void readFile(int *, HSC *);

void saveFile(int *, HSC *);

void border (void);

void anyKey (int *);

void scrollLeft12 (void);

void scrollRight12 (void);

int changeSymbol (int, int *);

void drawHint(int [][], int, int);

int try(int [][], int *, int *, int *, int *, int *, int *, int *, HSC *);

void about (int *);

void instructions (int *);

int editOptions (int *, HSC *);

void drawScreen(int [][], int);

int newGame (int [][], int *, HSC *);

void _main (void);


#endif
